// JavaScript Document
// author: Broes.nl
// this code may freely be used, changed and redistributed
// when you're literally copying and using the code, please refer to the author

var BroesUpdater = function() {
    // private properties
    var currentVersion = "2.10",
        lastTimeUpdateCheck = 0,
        versionUrl = "http://widgets.broes.nl/nlWeerradarVersion.php",
        downloadUrl = "http://www.broes.nl/widgets/nlweerradar/",
        updatePanel;
    
    // private methods
    
    function init(updatePanelId) {
        updatePanel = document.getElementById(updatePanelId);
        var updNoButton = new AppleGlassButton(document.getElementById("btnUpdateNo"), "Nee", dontUpdate); 
        var updYesButton = new AppleGlassButton(document.getElementById("btnUpdateYes"), "Ja, update", doUpdate);
    }
    
    function dontUpdate(e) {
        e.preventDefault();
        e.stopPropagation();
        updatePanel.style.display = "none";
    }
    
    function doUpdate(e) {
        e.preventDefault();
        e.stopPropagation();
        updatePanel.style.display = "none";
        GUI.openSite(downloadUrl);
    }
    
    function checkForUpdate() {
        var reqversion = new XMLHttpRequest();
        
        function compareVersion () { 
            if (reqversion.readyState === 4) {
                if (reqversion.status === 200) {
                    lastTimeUpdateCheck = Math.floor(new Date().getTime() / 1000);

                    if (currentVersion !== reqversion.responseText) {
                        document.getElementById("versioninfo").innerHTML = "Nieuwe versie beschikbaar!<br>Beschikbare versie: " + reqversion.responseText;
                        updateAvailable();
                    }
                    else {
                        document.getElementById("versioninfo").innerHTML = "Deze versie (" + currentVersion + ") is de meest recente.";
                    }
                }
                else {
                    document.getElementById("versioninfo").innerHTML = "Kan geen verbinding maken met server.";
                }
                reqversion = false;
            }
        }
        
        reqversion.onreadystatechange = compareVersion;
        reqversion.open("GET", versionUrl + "?version=" + currentVersion, true);
        reqversion.setRequestHeader("Cache-Control", "no-cache");
        reqversion.send(null);
    }

    function isItTimeToUpdate(updateNow) {
        var _updateNow = updateNow || false; // default false
        var isUpdateCheckAllowed = true; // default true

        if (window.widget) {
            var prefUpdateCheckAllowed = widget.preferenceForKey("updateAllowed");
            if (prefUpdateCheckAllowed) {
                isUpdateCheckAllowed = prefUpdateCheckAllowed;
            }
        }

        var dateNow = new Date();
        dateNow = Math.round(dateNow.getTime() / 1000);

        if (isUpdateCheckAllowed && (lastTimeUpdateCheck + 172800 < dateNow) || _updateNow) { // last update was more than 2 days ago
            checkForUpdate();
        }
    }

    function updateAvailable() {
        updatePanel.style.display = "block";
    }
    
    // public methods
    return {
        isItTimeToUpdate: isItTimeToUpdate,
        init: init,
        currentVersion: currentVersion
    }
}();