var LoadingSpinner = function() {
    
    // private properties
    var canvas;
    var ctx;
    var spinner = new Image();
    var spinning = false;
    var timeOutStop = 0;
    
    spinner.src = "images/loading_spinner.png";
    
    // private methods
    var init = function() {
        canvas = document.getElementById('loadingCanvas');
        ctx = canvas.getContext("2d");
        ctx.translate(25,25);
    };
    
    var redraw = function() {
        ctx.clearRect(-25, -25, 50, 50);
        ctx.drawImage(spinner, -25, -25);
    };
    
    var start = function() {
        canvas.style.display = "block";
        spinning = true;
        spin();
    };
    
    var spin = function() {
        if (spinning && timeOutStop < 600) { // stop spinning after (600*100)msec (1min)
            timeOutStop++;
            redraw();
            ctx.rotate(Math.PI*2/12);
            setTimeout(spin, 100);
        }
    };
    
    var stop = function() {
        canvas.style.display = "none";
        spinning = false;
        timeOutStop = 0;
    };
    
    
    // public methods
    return {
        init: init,
        start: start,
        stop: stop
    }
}();